// A hash-table implementation of a dict, with separate chaining..
// Requires dict.h and llist.h

#include "dict.h"
#include <string.h>
#include <stdlib.h>
#include "llist.h"
#include <iostream.h>
#include "trace.h"
#include "hash.h"

llist *
hash::bucketof (char *key) {
	int n = hashfunction(key, nb);
	trace("Bucketof <"); trace(key); trace("> is "); trace(n); trace(endl);
	return &( bucket[n] );
}

char *
hash::operator[] (char *key) {
	llist *whichbucket = bucketof (key);
	return (*whichbucket)[key];
}

int 
hash::ins (char *key, char *data) {
	llist *whichbucket = bucketof (key);
	return whichbucket->ins(key, data);
}

// From GNU libg++ hash.cc hashpjw
int 
hash::hashfunction(char* key, int max) // From Dragon book, p436
{
  unsigned int h = 0;
  unsigned int g;

  trace("Hashing <"); trace(key); trace("> yields "); 

  while (*key != '\0')
  {
    h = (h << 4) + *key++;
    if ((g = h & 0xf0000000) != 0)
      h = (h ^ (g >> 24)) ^ g;
  }

  trace(h); trace(endl);

  return (int) (h % max);
}
